#!/usr/bin/env python
#
# $Id: OptionToggle.py,v 1.4 2001/11/03 11:05:22 doughellmann Exp $
#
# Copyright 2001 Doug Hellmann.
#
#
#                         All Rights Reserved
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby
# granted, provided that the above copyright notice appear in all
# copies and that both that copyright notice and this permission
# notice appear in supporting documentation, and that the name of Doug
# Hellmann not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission.
#
# DOUG HELLMANN DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
# INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
# NO EVENT SHALL DOUG HELLMANN BE LIABLE FOR ANY SPECIAL, INDIRECT OR
# CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
# OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
# NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
# CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#

"""Special toggle button for use in option dialogs.

"""

__rcs_info__ = {
    #
    #  Creation Information
    #
    'module_name'  : '$RCSfile: OptionToggle.py,v $',
    'rcs_id'       : '$Id: OptionToggle.py,v 1.4 2001/11/03 11:05:22 doughellmann Exp $',
    'creator'      : 'Doug Hellmann <doug@hellfly.net>',
    'project'      : 'PmwContribD',
    'created'      : 'Sun, 01-Apr-2001 13:10:59 EDT',

    #
    #  Current Information
    #
    'author'       : '$Author: doughellmann $',
    'version'      : '$Revision: 1.4 $',
    'date'         : '$Date: 2001/11/03 11:05:22 $',
}

#
# Import system modules
#
import Pmw
from Tkinter import *


#
# Import Local modules
#


#
# Module
#


class OptionToggle(Pmw.LabeledWidget):
    """Special toggle button to use in option dialog.

    Components

      'checkbutton' -- Button user is going to change.

      'label' -- Label on the button.
      
    """
    def __init__(self, parent=None, **kw):
        optiondefs = (
            )
        self.defineoptions(kw, optiondefs)
        Pmw.LabeledWidget.__init__(self, parent=parent)
        interior = self.interior()
        w = self.createcomponent(
            'checkbutton',
            (), None,
            Checkbutton,
            (interior,),
            )
        w.pack(
            side=TOP,
            expand=NO,
            fill=X,
            )
        self.initialiseoptions(self.__class__)
        return
    
