#!/usr/bin/env python
# (C) 2000 Huaiyu Zhu <hzhu@users.sourceforge.net>.  Licence: GPL
# $Id: mfuncs.py,v 1.3 2001/08/26 12:40:43 hzhu Exp $
"""
mfuncs.py : Matrix-wise functions
"""

#import cephes
import MLab
from MatPy.Matrix import mfunc, mfuncC


#------------------------------------------------------------------
"""Matrix-wise functions.
Only analytical functions are meaningful.
"""

def sqrtm(x):
	"sqrtm(x) : matrix square root of x"
	return mfuncC(MLab.sqrt, x)

def expm(x):
	"expm(x) : matrix exponential of x"
	return mfuncC(MLab.exp, x)

def logm(x):
	"logm(x) : matrix logarithm of x base e"
	return mfuncC(MLab.log, x)

def sinhm(x):
	"sinhm(x) : matrix hyperbolic sine of x"
	return mfuncC(MLab.sinh, x)

def coshm(x):
	"coshm(x) : matrix hyperbolic cosine of x"
	return mfuncC(MLab.cosh, x)

def tanhm(x):
	"tanhm(x) : matrix hyperbolic tangent of x"
	return mfuncC(MLab.tanh, x)

def sinm(x):
	"sinm(x) : matrix sine of x"
	return mfuncC(MLab.sin, x)

def cosm(x):
	"cosem(x) : matrix cosine of x"
	return mfuncC(MLab.cos, x)

def tanm(x):
	"tanm(x) : matrix tangent of x"
	return mfuncC(MLab.tan, x)

def asinm(x):
	"asinm(x) : matrix arc sine of x"
	return mfuncC(MLab.arcsin, x)

def acosm(x):
	"acosm(x) : matrix arc cosine of x"
	return mfuncC(MLab.arccos, x)

def atanm(x):
	"atanm(x) : matrix arc tangent of x"
	return mfuncC(MLab.arctan, x)
