#! /usr/bin/env python
from Tkinter import *
import Tix, sys
root = Tix.Tk()


def deselect(index):
    # Turn off the highlighting of previous track
    global bg
    listbox.itemconfigure(index, background='%s'%bg)


def highlight_selection(index):
    # Turn on highlighting of current track.
    listbox.itemconfigure(index, background="white")
    root.update()


def init():
    # Set up any and all globals.
    global stop, new_disk, no_in_listbox, repeat, new_disk, previous_track
    global thread, time, os, classical
    import thread
    import time
    import os
    # Here I am importing the file that imported this one.
    # It seems to be needed so that I can cummicate back and forth.
    import classical
    stop = 0
    new_disk = 0
    no_in_listbox = 0
    repeat = 0
    new_disk = 0
    previous_track = 0

    # Start new thread which will refresh the GUI periodically.
    thread.start_new_thread(refresh, ())

    # After we create the GUI go back to the main routine which will
    # do the actual playing.
    classical.main()


def load_listbox(tracks):
    global no_in_listbox
    # Clear listbox from previous stuff.
    listbox.delete(0, no_in_listbox)
    no_in_listbox = 0
    for i in tracks:
        ip = i.split('/')
        show = ip[len(ip)-1]              # Get just the end
        show = show.split('.')[0]         # Leave the mp3 behind
        # The stuff that follows is there because whin I rip the CD's
        # I put into the file name first a track number and a random
        # integer.
        show = show.split('_', 2)
        show = show[0] + ' ' + show[2]    # Leave out the random number
        show = show.replace('_', ' ')     # Get rid of dashes.
        listbox.insert(END, show)         # Put in the list box.
        no_in_listbox += 1



def new_disk():
    # Like above but set global variable that is inspected and
    # causes main routine to select another disk at random.
    global new_disk
    new_disk = 1
    os.system('killall mpg123')


def next_track():
    # This kills the player and the main routine will go on
    # to next track or disk.
    os.system('killall mpg123')


def previous_track():
    global previous_track
    previous_track = 1
    os.system('killall mpg123')

def repeat_track():
    global repeat
    repeat = 1
    os.system('killall mpg123')

def quit():
    # Kill the player, set a global variable for the main program
    # to query.
    global stop
    stop = 1
    os.system('killall mpg123')
    sys.exit()


def refresh():
    # This is present so that I can go to another virtual desk top
    # or obscure the window and then when I return my gui will be
    # refreshed.
    while 1:
        root.update()
        time.sleep(0.5)


def save_object(o):
    # Just keeps a handle to the listbox in global space so that
    # it can easily be updated as the disks are changed.
    # I also retain the background color.
    global listbox
    global bg
    listbox = o
    bg= listbox.cget('bg')

def set_label(album):
    # Display the name of the disk.
    album = album.replace('_', ' ')
    w.lab24.configure(text='%s' % album)



class New_Toplevel_1:
    def __init__(self, master=None):

        self.lab24 = Label (master)
        self.lab24.place(in_=master,x=20,y=30)
        self.lab24.configure(activebackground="black")
        self.lab24.configure(activeforeground="#f4ddb2")
        self.lab24.configure(background="#f4ddb2")
        self.lab24.configure(borderwidth="1")
        self.lab24.configure(font="helvetica -12")
        self.lab24.configure(foreground="#000000")
        self.lab24.configure(highlightbackground="ivory")
        self.lab24.configure(relief="raised")
        self.lab24.configure(text="Album")
        self.lab24.configure(width="62")

        self.tix25 = Tix.ScrolledListBox(master)
        self.tix25.place(in_=master,x=20,y=60)
        self.tix25.configure(scrollbar="auto")
        self.tix25.configure(background="#f4ddb2")
        self.tix25.configure(borderwidth="1")
        self.tix25.configure(height="259")
        self.tix25.configure(highlightbackground="ivory")
        self.tix25.configure(highlightcolor="Black")
        self.tix25.configure(width="431")
        self.tix25_listbox = self.tix25.subwidget_list["listbox"]
        self.tix25_listbox.configure(background="#ffe7ba")
        self.tix25_listbox.configure(font="helvetica -12")
        self.tix25_listbox.configure(highlightbackground="ivory")
        self.tix25_listbox.configure(highlightthickness="2")
        self.tix25_listbox.configure(selectbackground="#800000")
        self.tix25_listbox.configure(selectforeground="#ffffff")
        self.tix25_listbox.configure(takefocus="1")
        save_object(self.tix25_listbox) # ldcmd .top24.tix25.listbox

        self.but26 = Button (master)
        self.but26.place(in_=master,x=30,y=360)
        self.but26.configure(background="#f4ddb2")
        self.but26.configure(command=next_track)
        self.but26.configure(disabledforeground="#808080")
        self.but26.configure(font="helvetica -12")
        self.but26.configure(foreground="#000000")
        self.but26.configure(highlightbackground="ivory")
        self.but26.configure(text="Next Track")

        self.but27 = Button (master)
        self.but27.place(in_=master,x=210,y=360)
        self.but27.configure(background="#f4ddb2")
        self.but27.configure(command=quit)
        self.but27.configure(disabledforeground="#808080")
        self.but27.configure(font="helvetica -12")
        self.but27.configure(foreground="#000000")
        self.but27.configure(highlightbackground="ivory")
        self.but27.configure(text="Quit")

        self.but28 = Button (master)
        self.but28.place(in_=master,x=360,y=360)
        self.but28.configure(background="#f4ddb2")
        self.but28.configure(command=new_disk)
        self.but28.configure(disabledforeground="#808080")
        self.but28.configure(font="helvetica -12")
        self.but28.configure(foreground="#000000")
        self.but28.configure(highlightbackground="ivory")
        self.but28.configure(text="New Disk")

        self.but23 = Button (master)
        self.but23.place(in_=master,x=30,y=400)
        self.but23.configure(background="#f4ddb2")
        self.but23.configure(command=repeat_track)
        self.but23.configure(disabledforeground="#808080")
        self.but23.configure(font="helvetica -12")
        self.but23.configure(foreground="#000000")
        self.but23.configure(highlightbackground="ivory")
        self.but23.configure(text="Repeat Track")

        self.but24 = Button (master)
        self.but24.place(in_=master,x=30,y=440)
        self.but24.configure(background="#f4ddb2")
        self.but24.configure(command=previous_track)
        self.but24.configure(disabledforeground="#808080")
        self.but24.configure(font="helvetica -12")
        self.but24.configure(foreground="#000000")
        self.but24.configure(highlightbackground="ivory")
        self.but24.configure(text="Previous Track")

        self.balloon = Tix.Balloon(master)
        self.balloon.configure(bg='blue', borderwidth=3)


def vp_start_gui():
    global w
    root.title('New_Toplevel_1')
    root.geometry('473x477+0+100')
    w = New_Toplevel_1 (root)
    init()
    root.mainloop()

if __name__ == '__main__':
    vp_start_gui()


