#! /usr/bin/env python

# This takes a python program generated by vtcl and put all of the
# user written procs back into the tcl version so that the GUI can
# be modified.

# It is called as follows:
#     python inc.py file_name_root
# or
#     python inc.py file_name_root.

import sys
import os
import string
import re

procs = []
proc_started = 0
def read_py_functions():
    global proc_started

    no = len(lines_py)
    for l in range(no): # Skip everything until first 'def' found
        if re.search(r'^def', lines_py[l]) != None:
            j = l
            break
    for i in range(j, no): # Process all the globals which occur
                           # before the 'class' statement.
        if string.strip(lines_py[i]) == "":
            continue
        if re.search(r'^def', lines_py[i]) != None:
            # construct header
            # get proc name include self. if in the class.
            sl = string.split(lines_py[i])
            proc_name = sl[1]
            if lines_py[i][0] == " ":  # def was indented.
                proc_name = "self." + proc_name
            pn = string.split(proc_name, "(")
            if proc_started == 1:
                procs.append("}\n")
            proc_started = 1
            ll = "proc " + pn[0] + " {} {\n"
            procs.append(ll)
        if lines_py[i][0:5] == "class":
            if proc_started == 1:
                procs.append("}\n")
            proc_started = 0
            j = i + 2
            break
        procs.append(lines_py[i])
    if proc_started == 1:
        procs.append("}\n")
    proc_started = 0

    for i in range(j, no): # Skip over the def __init__
                           # and go to the first internal 'def'.
        if re.search(r'^[ ]+def', lines_py[i]) != None:
            j = i
            break
    j = i
    for i in range(j, no): # Pick up class methods.
        if string.strip(lines_py[i]) == "":
            continue
        def_found = 0
        if string.find(lines_py[i],"def") != -1:
            def_found = 1
            # construct header
            # get proc name include self. if in the class.
            sl = string.split(lines_py[i])
            print "lines_py[i] =", lines_py[i]
            proc_name = sl[1]
            if string.find(proc_name, '(') > -1:
                ss = string.split(proc_name, '(', 1) # get rid of the '('
                proc_name = ss[0]
            print "proc_name =", proc_name
            if lines_py[i][0] == " ":  # def was indented.
                proc_name = "self." + proc_name
            if proc_started:
                procs.append("}\n")
            proc_started = 1
            ll = "proc " + proc_name + " {} {\n"

            print "proc_name =", proc_name
            print 'll =',ll
            procs.append(ll)
        if lines_py[i][0:2] == "if":
            break
        if def_found:
            procs.append(string.strip(lines_py[i])+'\n')
        else:
            procs.append(lines_py[i])
    if proc_started == 1:
        procs.append("}\n")


tcl_fore = []
tcl_aft = []

def fix_tcl_file():
    # Split the tcl into for and aft.

    no = len(lines_tcl)
    for i in range(no): # copy up to and including # USER DEFINED PROCEDURES
        tcl_fore.append(lines_tcl[i])
        if string.find(lines_tcl[i], "# USER DEFINED PROCEDURES") != -1:
            j = i
            break

    for i in range(j,no): # Skip over procs there
        if string.find(lines_tcl[i], "proc {Window} {args} {") != -1:
            j = i
            break
    for i in range(j,no): # Glomb onto the rest.
        tcl_aft.append(lines_tcl[i])

def replace(str, field, new):

    l = len(filed)
    i = string.find(str, field)
    if i == -1:
        return -1
    p = string.split(str, field, 1)
    return p[0] + new + p[1]

def replace_tabs(lines):
    for l in lines:
        while string.find(l, '\t') > -1:
            replace(l, '\t', '    ')

def main():
    global lines_py, lines_tcl
    if len(sys.argv) != 2:  # Check arguments
        print "No file name given."
        sys.exit()
    file_name = sys.argv[1]
    if file_name[-1] == ".":
        file_name = file_name[0:-1]
    py = open(file_name + ".py", 'r')
    lines_py = py.readlines()
    replace_tabs(lines_py)
    py.close()

    tcl = open(file_name + ".tcl", 'r')
    lines_tcl = tcl.readlines()
    tcl.close()

    read_py_functions()

    fix_tcl_file()

    tcl = open(file_name + ".tcl", 'w')

    for i in tcl_fore:
        tcl.write(i)
    for i in procs:
        tcl.write(i)
    for i in tcl_aft:
        tcl.write(i)

    tcl.close()

if __name__ == '__main__':
    main()












