#! /usr/bin/env python

# Program to conver a python GUI to a tcl file which will succeed as a
# target of a source statement within Page.

# It is given one parameter: the root name of the GUI file.


# NEEDS WORK - Figure out a way to handle the global stuff like
# import statements.

import sys
import os
import string
import re

MENU_BAR = 'menubar'

def w(x):
    #print x
    tcl.write(x)

def python_attributes():
    global new_lines
    w( '''
proc append_python_attributes {str} {
    global vTcl
    if {[info exists vTcl(special_attributes)] == 1} {
        if {[lsearch $vTcl(special_attributes) $str] != -1} {
            return
        }
     }
    lappend vTcl(special_attributes) $str
}
''')

def python_functions(info):
    # This writes out the python functions in the guise of
    # tcl functions.
    for obj in [info.class_method, info.method]:
        for m in obj.keys():
            s = "\nproc %s {} {\n" % m
            w(s)
            for stmt in obj[m]:
                w(stmt+'\n')
            w('}\n')

def write_configure(line, b_name):
    options, options_list_found = separate_options(line)
    for i in options:
        if options_list_found:
            i_split = string.split(i[0], ".", 1)
            ii = i_split[1]
        else:
            ii = i[0]
        w(b_name + ' configure -' + ii  + ' ' + i[1] + '\n')

def write_pack(line, b_name):
    options = separate_options(line)
    for i in options:
        w('pack ' + b_name + ' -' + i[0] + ' ' + i[1] + '\n')

def finish_menu(menu_name, lines):
    m_lines = []
    for i in lines:
        if string.find(i, menu_name) > -1:
            m_lines.append(string.strip(i))
    for i in m_lines:
        if string.find(i, 'Menubutton') > -1:
            b_name = '$base.' + menu_name
            w('menubutton ' + b_name + '\n')
            p = string.split(i, ',')
            for j in range(1, len(p)):
                pl = string.split(p[j], '=')
                x = string.strip(pl[0])
                y = string.strip(pl[1])
                if j == len(p)-1:
                    y = y[:-1]
                w(b_name + ' configure -' + x + ' ' + y + '\n')

        if string.find(i, menu_name + '.configure') > -1:
            write_configure(i, b_name)

        if string.find(i, menu_name + '.pack') > -1:
            write_pack(i, b_name)

def configure_menu(lines):
    # We know that we will need to put in a frame at the top.
    j = -1
    for i in lines:
        j = j + 1
        if string.find(i, 'menubar =') > -1:
            create_menubar(i)
            sys.exit()
        if string.find(i, 'Menubutton') > -1:
            # Pull out the menu name
            mo = re.search(r"self\.(men[0-9]+) =", i)
            if mo != None:
                menu_name = mo.group(1)
                finish_menu(menu_name, lines[j:])
                break

def add_toplevel(info):
    w('''
proc {Window} {args} {
global vTcl
    set cmd [lindex $args 0]
    set name [lindex $args 1]
    set newname [lindex $args 2]
    set rest [lrange $args 3 end]
    if {$name == "" || $cmd == ""} {return}
    if {$newname == ""} {
        set newname $name
    }
    set exists [winfo exists $newname]
    switch $cmd {
        show {
            if {$exists == "1" && $name != "."} {
                wm deiconify $name
                return
            }
            if {[info procs vTclWindow(pre)$name] != ""} {
                eval "vTclWindow(pre)$name $newname $rest"
            }
            if {[info procs vTclWindow$name] != ""} {
                eval "vTclWindow$name $newname $rest"
            }
            if {[info procs vTclWindow(post)$name] != ""} {
                eval "vTclWindow(post)$name $newname $rest"
            }
        }
        hide    { if $exists {wm withdraw $newname; return} }
        iconify { if $exists {wm iconify $newname; return} }
        destroy { if $exists {destroy $newname; return} }
    }
}
''')

#    # Get information about the top level widget.
#    # Run thru all the lines, noting which line defines the class.

    str = ('''
proc vTclWindow.top24 {base {container 0}} {
    if {$base == ""} {
        set base .top24
    }
    if {[winfo exists $base] && (!$container)} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    if {!$container} {
    toplevel $base -class Toplevel -background wheat %s
    wm focusmodel $base passive
    wm geometry $base %s
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base %s
    }
''') % (info.top_level_menu, info.root_geom, info.root_title)
    w(str)

def write_menubar_code():
    w('''
proc Menu_Setup { menubar } {
        global menu
        menu $menubar
        # Associated menu with its main window
        set top [winfo parent $menubar]
        $top config -menu $menubar
        set menu(menubar) $menubar
        set menu(uid) 0
}
proc Menu { label } {
        global menu
        if [info exists menu(menu,$label)] {
                error "Menu $label already defined"
        }
        # Create the cascade menu
        set menuName $menu(menubar).mb$menu(uid)
        incr menu(uid)
        menu $menuName -tearoff 1
        $menu(menubar) add cascade -label $label -menu $menuName
        # Remember the name to menu mapping
        set menu(menu,$label) $menuName
}
''')

class input:
    # Class to handle all the input.
    def __init__(self, file_name):
        py = open(file_name, 'r')
        self.lines_py = py.readlines()
        py.close()
        self.lines = self.replace_tabs(self.lines_py)
        self.line_curr = 0
        self.line_max = len(self.lines_py)

    def replace_tabs(self, lines):
        for l in lines:
            while string.find(l, '\t') > -1:
                l = string.replace(l, '\t', '    ')
            l = string.strip(l)
        return lines

    def get_next_line(self):
        while 1:
            # Loop toskip over blank lines.
            if self.line_curr == self.line_max:
                # We're done.
                return -1
            l = self.lines[self.line_curr]
            self.line_curr = self.line_curr + 1
            l = string.rstrip(l)  # Remove leading and trailing ws.
            if l != '' and l[0] != '#':
                break
#            if l[0] != '#':
#                break   # Skip comment lines.
        while l[-1] == "\\":
            l = l[:-1] + ',' + string.strip(self.lines[self.line_curr])
            self.line_curr = self.line_curr + 1
        return l

    def reset_curr(self, index):
        self.line_curr = index

class process_widgets:
    # Here is where I put everything that has to do with processing
    # widgets.  I write a lot of classes where I do nothing but initialize
    # them.  This is one.
    def __init__(self, inp):
        self.suffix = 0
        self.menu_button = 0
        self.compile_patterns()
        # On the first pass thru the python code, I noted where my class
        # started.  Here I reset get_next_line to that point.  Note the
        # assumption that there is only one class in the Python GUI code!!!
        inp.reset_curr(class_index)
        self.inp = inp
        self.sp_attr = []
        self.add_widgets(inp)

    def compile_patterns(self):
        # These are all the regular expression I use for recognizing
        # one of my generated python lines.  I prefer snobol pattern matching.
        # I found visual_regexp very helpful.
        self.paren_patt = r'\((.*)\)'
        self.widget_patt =  \
            r'self\.([a-zA-Z0-9_]+) *= *([A-Za-z.]+) *\((\w.*)\)'
        self.config_patt = r'self\.([a-zA-Z0-9_]+)\.configure *\('
        self.place_patt = r'self\.([a-zA-Z0-9_]+)\.place *\('
        self.pack_patt = r'self\.([a-zA-Z0-9_]+)\.pack *\('
        self.bind_patt = r'self\.([a-zA-Z0-9_]+)\.bind *\((.*)\)'
        self.menubar_patt = r'self\.menubar *='
        self.add_cascade_patt = r'self\.([a-zA-Z0-9_]+)\.add_cascade *\((.*)\)'
        self.add_checkbutton_patt = \
                            r'self\.([a-zA-Z0-9_]+)\.add_checkbutton *\((.*)\)'
        self.add_command_patt = r'self\.([a-zA-Z0-9_]+)\.add_command *\((.*)\)'
        self.add_radiobutton_patt = \
                           r'self\.([a-zA-Z0-9_]+)\.add_radiobutton *\((.*)\)'
        self.add_separator_patt = \
                           r'self\.([a-zA-Z0-9_]+)\.add_separator *\((.*)\)'
        self.add_patt = \
                           r'self\.([a-zA-Z0-9_]+)\.add *\((.*)\)'
        self.def_patt = r'^[ ]*def '
        self.men_patt = r'men[0-9]+'
        self.balloon_patt = r'self\.balloon'
        self.ldcmd_patt = r'# ldcmd'
        self.bindcmd_patt = r'# bindcmd'

        self.paren_r = re.compile(self.paren_patt)
        self.widget_r = re.compile(self.widget_patt)
        self.config_r = re.compile(self.config_patt)
        self.place_r = re.compile(self.place_patt)
        self.pack_r = re.compile(self.pack_patt)
        self.bind_r = re.compile(self.bind_patt)
        self.menubar_r = re.compile(self.menubar_patt)
        self.add_cascade_r = re.compile(self.add_cascade_patt)
        self.add_checkbutton_r = re.compile(self.add_checkbutton_patt)
        self.add_command_r = re.compile(self.add_command_patt)
        self.add_radiobutton_r = re.compile(self.add_radiobutton_patt)
        self.add_separator_r = re.compile(self.add_separator_patt)
        self.add_r = re.compile(self.add_patt)
        self.def_r = re.compile(self.def_patt)
        self.men_r = re.compile(self.men_patt)
        self.balloon_r = re.compile(self.balloon_patt)
        self.ldcmd_r = re.compile(self.ldcmd_patt)
        self.bindcmd_r = re.compile(self.bindcmd_patt)



    def add_widgets(self, inp):
        # Here I run thru all the lines of the top level class stopping
        # when I hit a def statement. (Note that I skip over the def __init__()
        # at the beginning.
        # Classify each widget and take appropriate action.
        while 1:
            line = inp.get_next_line()
            if line == -1: return
            # Check for termination conditions.
            if self.def_r.search(line):            # stop on a def stmt.
                if string.find(line, '__init__') == -1:
                    w('\n}\n')
                    return
            if string.find(line, 'if ') == 0:
                w('\n}\n')
                return    # stop on an if stmt.
            if self.balloon_r.search(line): # balloon stuff is last; so stop.
                    w('\n}\n')
                    return



            mo = self.widget_r.search(line)
            if mo != None:
                self.construct_widget(mo, line)
                continue

            mo = self.pack_r.search(line)
            if mo != None:
                self.construct_pack(mo, line)
                continue

            mo = self.bindcmd_r.search(line)
            if mo != None:
                self.save_bindcmd(line)

            mo = self.bind_r.search(line)
            if mo != None:
                self.construct_bind(mo, line)
                continue

            mo = self.config_r.search(line)
            if mo != None:
                self.construct_configure(mo, line)
                continue

            mo = self.place_r.search(line)
            if mo != None:
                self.construct_place(mo, line)
                continue


            mo = self.add_cascade_r.search(line)
            if mo != None:
                self.construct_add_menu_stuff('cascade', mo, line)
                continue

            mo = self.add_checkbutton_r.search(line)
            if mo != None:
                self.construct_add_menu_stuff('checkbutton', mo, line)
                continue

            mo = self.add_command_r.search(line)
            if mo != None:
                self.construct_add_menu_stuff('command', mo, line)
                continue

            mo = self.add_radiobutton_r.search(line)
            if mo != None:
                self.construct_add_menu_stuff('radiobutton', mo, line)
                continue

            mo = self.add_separator_r.search(line)
            if mo != None:
                self.construct_add_menu_stuff('separator', mo, line)
                continue

            mo = self.add_r.search(line)
            if mo != None:
                self.construct_add(mo, line)
                continue

            mo = self.ldcmd_r.search(line)
            if mo != None:
                self.save_ldcmd(line)


    def construct_widget(self, mo, line):
        global current_menu_type
        name  = mo.group(1)
        #print "construct_widget: name =", name
        if string.find(name,'_') > -1:
            name = self.fix_name(name)
        type = self.fix_type(mo.group(2))

        # There are 3 special cases dealing with menus.
        if type == 'menubutton':
            self.menu_button = 1
            current_menu_type = type
            self.suffix = self.suffix + 1
            str = 'menubutton $base.menubar.%s -menu "$base.menubar.%s.m%d"' \
                  % (name, name, self.suffix)
            # Split the argument string, and discare the first element
            # get all the parameters
            conf = string.split(mo.group(3), ',')
            del conf[0]
            for c in conf:
                sp = string.split(c, '=')
                str = "%s -%s %s" % (str, string.strip(sp[0]), sp[1])
            w(str+'\n')
            return
        if type == 'menu':
            parent = mo.group(3)
            if string.find(parent, 'self.') != 0:
                print 'error. malformed Menu statement'
                sys.exit()
            parent = parent[5:]
            str = "menu $base.%s" % name
            # Split the argument string, and discare the first element
            # get all the parameters
            conf = string.split(mo.group(3), ',')
            del conf[0]
            for c in conf:
                sp = string.split(c, '=')
                str = "%s -%s %s" % (str, string.strip(sp[0]), sp[1])
            #str = '%s -%s "%s.m"' % (str, 'menu', parent)
            #self.suffix = self.suffix + 1
            w(str+'\n')
            return
        name = '$base.%s' % name
        str = '%s %s' % (type, name)
        if type == 'tixComboBox':
            # get all the parameters
            conf = string.split(mo.group(3), ',')
            del conf[0]
            for c in conf:
                sp = string.split(c, '=')
                str = "%s -%s %s" % (str, string.strip(sp[0]), sp[1])
            w(str+'\n')
            return
        if type == 'tixOptionMenu' or type == 'menu':
            current_menu_type = type
        w(str+'\n')
        self.config(name, line)

    def construct_menubar(self, line):
        # Not Used.
        w('# construct_menubar\n')
        #write_menubar_code()
        #w('# after write_menubar_code\n')
        name = '$base.%s' % MENU_BAR
        str = 'menu %s\n' % name
        w(str)


    def construct_pack(self, mo, line):
        name = mo.group(1)
        name = self.fix_name(name)
        name = '$base.%s' % name
        str = 'pack %s' % name
        w(str)
        options, options_list_found = self.separate_options(line)
        if options[0][1] == '' and not options_list_found:
            options = options[1:]
        for opt in options:
            x = ' -%s %s' % (opt[0], opt[1])
            w(x)
        sys.exit
        w('\n')

    def construct_bind(self, mo, line):
        name = mo.group(1)
        if name == 'menubar':
            return
        name = self.fix_name(name)
        name = '$base.%s' % name
        args = mo.group(2)
        args = string.split(args, ',')
        # Play with args[0], to ge rid of the quote.
        str = 'bind %s %s {%s}\n' % (name, args[0][1:-1], args[1])
        w(str)

    def config(self, name, line):
        options, options_list_found = self.separate_options(line)
        if options_list_found:
            oo = options[1][0]
            ooo = string.split(oo, '.', 1)
            o_name = ooo[0]
            w('set %s [%s subwidget %s]\n' % (o_name, name, o_name))
            wid = '$' + o_name
        else:
            wid = name
        if options[0][1] == '' and not options_list_found:
            options = options[1:]
        for opt in options:
            if options_list_found:
                o_split = string.split(opt[0], '.', 1)
                oo = o_split[1]
            else:
                oo = opt[0]
            if oo == 'command' or oo == 'browsecmd':
                str = '%s configure -%s {%s}\n' % (wid, oo, opt[1])
            else:
                str = '%s configure -%s %s\n' % (wid, oo, opt[1])
            w(str)

    def separate_options(self, line):
        mo = self.paren_r.search(line)
        if mo == None:
            print 'Error: separate_options'
            sys.exit()
        c = mo.group(1)
        options = []
        options_list_found = 0
        if string.find(c, "options=',") > -1:
            options_list_found = 1
            split = string.split(c, "options=',")
            c = split[1][:-1]
            c = string.lower(c)
        comma_split = string.split(c, ',')
        for i in comma_split:
            if string.find(i, '=') == -1:
                x = i
                y = ''
            else:
                eq_split = string.split(i, '=', 1)
                x = string.strip(eq_split[0])
                y = string.strip(eq_split[1])
                if x == 'side' or x == 'relief' or x == 'fill':
                    y = string.lower(y)
            options.append([x, y])
        return (options, options_list_found)

    def construct_configure(self, mo, line):
        name = mo.group(1)
        if name == 'menubar':
            return
        name = self.fix_name(name)
        name = '$base.%s' % name
        self.config(name, line)

    def construct_add_menu_stuff(self, thing, mo, line):
        name = mo.group(1)
        name = self.fix_name(name)
        options = mo.group(2)
        if string.find(options, ',') > -1:
            options = string.split(options, ',')
        else:
            options = [options]
        x = ''
        if current_menu_type == 'tixOptionMenu':
            funky = options[0]
            thing = "%s %s" % (thing, funky)
            options = options[1:]
            w('#options = %s\n' % str(options))
        for o in options:
            op = string.split(o, '=')
            if op[0] == 'command':
                x = '%s -%s {%s}' % (x, op[0], op[1])
            else:
                if op[0] == 'menu':
                    op[1] = self.menu_fix(op[1])
                x = '%s -%s %s' % (x, op[0], op[1])
        strg = '$base.%s add %s %s\n' % (name, thing, x)
        w(strg)

    def construct_add(self, mo, line):
        name = mo.group(1)
        name = self.fix_name(name)
        options = mo.group(2)
        if string.find(options, ',') > -1:
            options = string.split(options, ',')
        else:
            options = [options]
        w('#name = %s\n' % name)
        w('#options = %s\n' % str(options))
        x = ''
        thing = options[0]
        del options[0]
        for o in options:
            op = string.split(o, '=')
            if op[0] == 'command':
                x = '%s -%s {%s}' % (x, op[0], op[1])
            else:
                x = '%s -%s %s' % (x, op[0], op[1])
        strg = '$base.%s add %s %s\n' % (name, thing, x)
        w(strg)

    def construct_place(self, mo, line):
        name = mo.group(1)
        name = self.fix_name(mo.group(1))
        name = "$base.%s" % name
        s = "place %s -anchor nw " % name
        options, options_list_found = self.separate_options(line)
        for oo in options:
            if oo[0] == 'in_': continue
            s = s + "-%s %s " % (oo[0], oo[1])
        w(s+'\n')

    def fix_name(self, name):
        # Replace python names with '_' to tk hierarchy with '.'.
        n_l = string.split(name, '_')
        nn = n_l[0]
        if self.men_r.search(nn):
            nn = 'menubar.' + nn
        n_l = n_l[1:]
        for n in n_l:
            nn = "%s.%s" % (nn, n)
        return nn

    def save_bindcmd(self, line):
        # Since I have special special attrbutes, I have to treat them
        # specially.  Specificly, I generate tcl statements which will
        # commit the information in the same data structure where the
        # normal attributes are saved.
        split = string.split(line, '# bindcmd')
        s0 = string.strip(split[0])
        s1 = string.strip(split[1])
        s1_p = s1.split('.', 2)
        s2 = '.%s.%s' % ('top24', s1_p[2])
        s0_p = s0.split(',', 1)
        s3 = s0_p[1][:-1]
        str = "set vTcl(w,opt,-bindcommand,%s) \"%s\"\n" % (s2, s3)
        self.sp_attr.append(str)
        str = "append_python_attributes \"vTcl(w,opt,-bindcommand,%s)\"\n" % s2
        self.sp_attr.append(str)

    def save_ldcmd(self, line):
        split = string.split(line, '# ldcmd')
        s0 = string.strip(split[0])
        s1 = string.strip(split[1])
        s1_p = s1.split('.', 2)
        s2 = '.%s.%s' % ('top24', s1_p[2])
        str = "set vTcl(w,opt,-loadcommand,%s) \"%s\"\n" % (s2, s0)
        self.sp_attr.append(str)
        str = "append_python_attributes \"vTcl(w,opt,-loadcommand,%s)\"\n" % s2
        self.sp_attr.append(str)

    def fix_type(self, type):
        # Have to fiddle around with case for the Tix widgets.
        if string.find(type, "Tix.") == 0:
            ret = 'tix%s' % type[4:]
        else:
            ret = string.lower(type)
        return ret

    def menu_fix(self, str):
        res = string.split(str, 'self.')
        piece = res[-1]
        new_piece = self.fix_name(piece)
        return new_piece

class info_obj:
    # This object will contain information gathered from a scan
    # of the py file.  We obtain (1) method definitions, (2) Top
    # Window characteristics, (3) Where the window class begins.
    # Unfortunately, I don't see a clever way to avoid two passes.
    def __init__(self, inp):
        global class_index
        self.top_level_menu = ''
        def_found = 0
#        class_def_found = 0
        self.method = {}
        self.class_method = {}
        def_patt = r'^[ ]*def +[\(](.*)[\)]'
        def_patt = r'(^[ ]*def (.*)\(.*:)'
        def_r = re.compile(def_patt)
        # Look at the next three lines!  Wouldn't it be nice if Python
        # supported something like
        # while assign(line, inp.get_next_line()):
        while 1:
            line = inp.get_next_line()
            #print "info_obj: line =", line
            if line == -1: break
            if string.find(line, "def ") > -1:
                mo = def_r.search(line)
                if mo:
                    name = mo.group(2)
                    if name == '__init__':
                        # Skip this one.
                        continue
                    else:
                        def_found = 1
                        self.method[name] = []
            if string.find(line, "class ") == 0:
                #found the class statement
                class_index = inp.line_curr
                mo = re.search(r" (.+):", line) # extract the class name.
                if mo != None:
                    self.root_title = mo.group(1)
                def_found = 0
                continue
            if string.find(line, 'root.geometry') > -1:
                mo = re.search(r"'(.*)'", line) # extract the geometry.
                if mo != None:
                    self.root_geom = mo.group(1)
                def_found = 0
                continue
            if string.find(line, 'menubar') > -1:
                if string.find(line, '(master,') > -1:
                    self.top_level_menu = '-menu "$base.%s"' % MENU_BAR
                def_found = 0
                continue
            if def_found:
                # This where we save the method definitions.
                # Note that line has been stripped of white space.
                # I may want to go back and change that.
                self.method[name].append(line)
                continue

def write_special_attributes(obj):
    for i in range(len(obj.sp_attr)):
        w(obj.sp_attr[i])

def final_stmts():
    w('\nWindow show .top24\n')

def main():
    global tcl
    #if len(sys.argv) != 2:  # Check arguments
    #    print "No file name given."
    #    sys.exit()
    #file_name = sys.argv[1]
    file_name = '/home/rozen/python/classic/classgui'
    if file_name[-1] == ".":
        file_name = file_name[0:-1]
    inp  = input(file_name + ".py")
    tcl = open(file_name + ".tcl", 'w')
    info = info_obj(inp)
    python_attributes()
    add_toplevel(info)

    ww = process_widgets(inp)
    python_functions(info)
    write_special_attributes(ww)
    final_stmts()

if __name__ == "__main__":
    main()



