#!/usr/bin/env python
# pymat make script and test for nd arrays
# By rolv@atmos.washington.edu

compile = False

if compile:
    MATLAB_DIR = '/usr/local/matlab-r13'

    import socket, os 
    if socket.gethostname() == 'modon2': # Gregs Linux computer
	MATLAB_DIR='/home/disk/damp_local/matlab-r13'
	#NUMERIC_INCLUDE='/home/modon2/hakim/bin/include/python2.3/Numeric'
	
	
	LD_LIBRARY_PATH = MATLAB_DIR+'/extern/lib/glnx86'
	LD_LIBRARY_PATH2 = MATLAB_DIR+'/sys/os/glnx86'
	try:
	    if not LD_LIBRARY_PATH in os.environ['LD_LIBRARY_PATH']:  
		raise Exception
	    if not LD_LIBRARY_PATH2 in os.environ['LD_LIBRARY_PATH']:
		raise Exception
	except:
	    print "\nAdd\n %s \nand\n %s\n to environment variable LD_LIBRARY_PATH\n\n" \
	    %(LD_LIBRARY_PATH, LD_LIBRARY_PATH2)
	    #Add this to .cshrc
	    #setenv LD_LIBRARY_PATH /home/disk/damp_local/matlab-r13/extern/lib/glnx86                                                                                                
	    #setenv LD_LIBRARY_PATH ${LD_LIBRARY_PATH}:/home/disk/damp_local/matlab-r13/sys/os/glnx86   
	    raise Exception
	
    MATLAB_INCLUDE = MATLAB_DIR +'/extern/include'
    MATLAB_LIB = MATLAB_DIR +'/extern/lib/glnx86'
    PYTHON_VERSION = '2.3'
    PYTHON_INCLUDE = '/usr/include/python' +PYTHON_VERSION
    NUMERIC_INCLUDE = PYTHON_INCLUDE +'/Numeric'
  
    

    INCLUDE = "-I" +MATLAB_INCLUDE +" -I" +NUMERIC_INCLUDE +" -I" +PYTHON_INCLUDE
    LINK = "-L" +MATLAB_LIB +" -leng -lmx -lmat -lut -Wl,-rpath," +MATLAB_LIB
    
    OPTIONS = ""#" -O2 -Wall -g2" #"-O3 "
    OPTIONS2 = " -shared"
    
    #FIRST CREATE pymat.o
    command1 = 'g++ ' +OPTIONS +' -c ../src/pymat.cpp ' +INCLUDE +' -o pymat.o' +" -Wno-deprecated"
    #CREATE pymatmodule.so
    command2 = "g++ " +OPTIONS2 +" -o pymatmodule.so pymat.o " +LINK 
    
    print command1
    print command2
    import os
    if os.system(command1) or os.system(command2):
	raise Exception, "Compile failure"


    #raw_input()
def c2f(arrayName):
    """
    Generate matlab command for the conversion of `arrayName`
    from row-major storage to column-major storage.
    """    
    return "%s=permute(reshape(%s,fliplr(size(%s))),[ndims(%s):-1:1])" \
           %(arrayName, arrayName, arrayName, arrayName)

def f2c(arrayName):
    """
    Generate matlab command for the conversion of `arrayName`
    from column-major storage to row-major storage.
    """    
    return "%s=reshape(permute(%s,[ndims(%s):-1:1]),size(%s))" \
           %(arrayName, arrayName, arrayName, arrayName)
	   
def leaktest():
    # Test for memory leakage
    import gc
    gc.set_debug(gc.DEBUG_LEAK)
    myMat = ones((1000**2, 2),'d')
    for i in range(5):
        pymat.put(h, 'foo', array(myMat, 'd', True))
        gc.collect()
	   
def test(h, name, someMatrix=False):
    """
    h is matlab engine handle
    name is a string indicating name of array in matlab,

    If someMatrix is passed, then the matrix is put into matlab under the name
    `name`, othervise `name` has to equal the name of an already existing
    array in the matlab-namespace. 
    """
    if someMatrix:
        pymat.put(h, name, someMatrix)
    else: 
        someMatrix=pymat.get(h, name)

    shape_ = shape(someMatrix)
        
    def loop(someMatrix, thisloop=0, *indices, **kwargs):
        """Recurse the matrix until last index is used equals thisloop"""
        indices = list(indices)
        shape_ = shape(someMatrix)
                
        if thisloop == len(indices):
            #Print 
            ind2=tuple(ones(len(indices))+indices).__str__() # Matlab index
            print indices,\
                  someMatrix[indices],\
                  ind2, \
                  pymat.eval(kwargs['h'],"%s%s" \
                             %(kwargs['name'],ind2)\
                             ).split('\n')[3].strip()
        else: # Recurse further
            for i in range(shape_[thisloop]):
                if i >= indices[thisloop]:
                    indices[thisloop] = i
                    loop(someMatrix, thisloop+1, *indices, **kwargs)
            
    print 'indicies (row, column, page,...)' , 'pythonvalue',\
          'matlabindicies', 'matlabvalue'
    kwargs = {'h':h, 'name':name}
    loop(someMatrix, 0, *rank(someMatrix)*[0], **kwargs)
	   
	   
import pymat
try:
    h = pymat.open('matlab -nodesktop -nojvm -nosplash')
except:
    h = pymat.open()
    
from Numeric import reshape, ones, array, shape, rank, transpose

a = [111, 112, 113, 121, 122, 123, 211, 212, 213, 221, 222, 223,
     311, 312, 313, 321, 322, 323, 411, 412, 413, 421, 422, 423]

b = reshape(a, (4,2,3))

pymat.put(h, 'b', b); #pymat.eval(h,c2f('b'))
print 'b=',b, pymat.eval(h, 'b')

pymat.eval(h, 'A = [5 7 8; 0 1 9; 4 3 6];')
pymat.eval(h, 'A(:,:,2) = [1 0 4; 3 5 6; 9 8 7];')
pymat.eval(h, 'M=A(1,:,:);')

#print pymat.eval(h,'A')
#print pymat.eval(h,'M')


#raw_input()

#pymat.eval(h,f2c('M')) #2d
#pymat.eval(h, f2c('A')) #Nd, N > 2

assert pymat.get(h, 'M') == pymat.get(h, 'A')[0, :,:]

pymat.eval(h, 'A=reshape([1,2,3;4 5 6],[2,3])')
#print 'A(:)', pymat.eval(h, 'A(:)')
#print 'A(1,:)', pymat.eval(h, 'A(1,:)')
#print 'A(:,1)', pymat.eval(h, 'A(:,1)')

A = pymat.get(h,'A')
B = reshape(range(1,7),(2,3))
#print A, B
assert A == B  # Evals to true anyway, since first item in both column and \
               # row-major storage arrays is the same.

assert A[:,1] == B[:,1]

#leaktest()

# Put tests
test(h,'B',b)
test(h,'A',A)

# Get tests
test(h,'A')

# Arrays from matlab are still fortran contiguous.
b_fcontiguous = pymat.get(h, 'b')
assert b_fcontiguous == b
assert b_fcontiguous.iscontiguous() == 0
assert b_fcontiguous.__copy__().iscontiguous() == 1

if not b.iscontiguous():
    b = b.copy()
    
print "testing put of f-contiguous arrays"
test(h,'btrans',transpose(b))
test(h,'btrans')
btrans = pymat.get(h,'btrans')
assert btrans.iscontiguous() == 0
assert transpose(b) == btrans

print "testing slice of c-contiguous array (slice is not contiguous)"
bslice = b[0:1,0:2,2]
assert bslice.iscontiguous() == 0
test(h,'bslice',bslice)
test(h,'bslice')


def crash():
    """Last fix only worked for array types"""
    print 'testing nonarray types'
    pymat.put(h,'list1',[1,2])
    print pymat.get(h,'list1')
    pymat.put(h,'string','What should we do with the d....')
    print pymat.get(h,'string')
    
crash()

