/******************************************** 
	copyright 2001 McMillan Enterprises, Inc.
	www.mcmillan-inc.com
*********************************************/
#if !defined(PWOMODULE_H_INCLUDED_)
#define PWOMODULE_H_INCLUDED_

#include "PWOBase.h"
#include "PWOMapping.h"

class PWOModule : public PWOBase
{
private:
	PWOModule() : PWOBase(0) {};
public:
	PWOModule(const char *nm) : PWOBase(PyModule_New((char*)nm)) { LoseRef(_obj); };
	PWOModule(PyObject *obj) : PWOBase(obj) {
		_violentTypeCheck();
	};
	virtual ~PWOModule() {};
	virtual PWOModule& operator=(const PWOModule& other) {
		GrabRef(other);
		return *this;
	};
	PWOModule& operator=(const PWOBase& other) {
		GrabRef(other);
		_violentTypeCheck();
		return *this;
	};
	virtual void _violentTypeCheck() {
		if (!PyModule_Check(_obj)) {
			GrabRef(0);
			throw PWException(PyExc_TypeError, "Not a module object");
		}
	};
	PWOMapping getDict() {
		return PWOMapping(PyModule_GetDict(_obj));
	};
	char *getName() {
		return PyModule_GetName(_obj);
	};
	char *getFilename() {
		return PyModule_GetFilename(_obj);
	};
};

#endif

